<?php
/**
 * Debit API Demo
 * version 1.0
 * 
 * author: Thorsten Kugler 
 * email: tkugler@micropayment.de
 * supported 2009 by micropayment
 */

	require_once( 'config.php' );
	require_once( './lib/init.php' );
	require_once( './lib/services/' . MCP__DEBITSERVICE_INTERFACE . '.php' );
	require_once( MCP__SERVICELIB_DISPATCHER . 'TNvpServiceDispatcher.php');  


//TNvpServiceDispatcher object, Debit-API service client
	try {
		$dispatcher = new TNvpServiceDispatcher(MCP__DEBITSERVICE_INTERFACE, MCP__DEBITSERVICE_NVP_URL);
	}
	catch ( Exception $e ) {
		print $e->getMessage();
		exit(1);
	}

// ermittelt GET-Param oder defaultwert
	function getGetVar($name, $default = '') {
		return isset($_GET[$name]) ? $_GET[$name] : $default;
	}
// ermittelt POST-Param oder defaultwert
	function getPostVar($name, $default = '') {
		return isset($_POST[$name]) ? $_POST[$name] : $default;
	}
// ermittelt SESSION-Variable oder defaultwert
	function getSessionVar($name, $default = '') {
		return isset($_SESSION[$name]) ? $_SESSION[$name] : $default;
	}
// ermittelt SESSION-Variable oder defaultwert
	function setSessionVar($name, $value) {
		$_SESSION[$name] = $value;
	}

//set vars to template
	function getTemplate () {
		
		$tmp = new Template(func_get_arg(0));
		
		for ($i = 1; $i < func_num_args(); $i++) {
			$param1 = func_get_arg($i);
			$i += 1;
			$param2 = func_get_arg($i);
			$tmp -> setContent($param1, $param2);
		}
		
		$tmp -> setContent('title', 'Debit API - Demo ');
		$tmp -> setContent('customerId', getCustomerName());
		$tmp -> setContent('counter1', countProductsTmp());
		$tmp -> setContent('counter2', countProducts());
		print $tmp -> vorlage;
	}

	
//products quantity in "shopping bag"
	function countProductsTmp() {
		
		session_name('debit');
		session_start();
		
		$countProductsTmp = 0;
		if (isset($_SESSION['products'])) {
			foreach  ($_SESSION['products'] as $product => $count) {
				$countProductsTmp += $count;
			}
			return "<b>(".$countProductsTmp.")</b>";
		} else {
			return "<b>(0)</b>";;
		}
	}


//counter for quantity of products bought	
	function countProducts() {
		
		session_name('debit');
		session_start();
		
		try {
			$dispatcher = new TNvpServiceDispatcher(MCP__DEBITSERVICE_INTERFACE, MCP__DEBITSERVICE_NVP_URL);
			$sessionData = array();
			$sessionData = $dispatcher -> sessionList(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION['customerId']);
			return "<b>(".$sessionData['count'].")</b>";
		}
		catch (Exception $e) {
			return "<b>(0)</b>";
		}
	}

	
//format amount to xx,xx	
	function formatAmount($amount) {
		return number_format($amount, 2, ',', '.');
	}


//template class	
	class Template {
		var $vorlage;
		function Template($vorlage) {
			$this -> setVorlage($vorlage);
		}

		function setVorlage($vorlage) {
			if(file_exists($vorlage)) {
				$fp = fopen($vorlage, "r");
				$text = fread($fp, filesize($vorlage));
				fclose($fp);
				$this -> vorlage = $text;
			} else {
				$this -> vorlage = $vorlage;
			}
		}

  		function setContent($param1, $param2="") {
			$this -> setOne($param1, $param2);
		}

		function setOne($suchWort, $substitution) {
			$this -> vorlage = str_replace("{".$suchWort."}",
			$substitution,
			$this -> vorlage);
		}
 
		function setArray($Array) {
			foreach ($Array as $suchWort => $substitution) {
			$this -> setOne($suchWort, $substitution);
			}
		}
	}
	
		
//returns CustomerId or guest status
//this isn't sophisticated, but customerCreate in guest mode creates customerIds with length = 40
	function getCustomerName() {

		session_name('creditcard');
		session_start();
		
		if (strlen($_SESSION['customerId']) > 30) {
			return "<em>Gast</em>";
		}
		else {
			return $_SESSION['customerId'];
		}
	}	
	

?>